#include <iostream>
#include "ThoiGian.h"

using namespace std;

ThoiGian::ThoiGian(int gio, int phut, int giay)
    : m_gio(gio), m_phut(phut), m_giay(giay){

}

ThoiGian& ThoiGian::operator+=(ThoiGian const& a){
    //1 : Cong so giay
    m_giay += a.m_giay;
    //Neu so giay vuot qua 60, cong them vao so phut
    m_phut+= m_giay / 60;
    m_giay %= 60;
    //2 : Cong so phut
    m_phut += a.m_phut;
    //Neu so phut vuot qua 60, cong them vao so gio
    m_gio += m_phut / 60;
    m_phut %= 60;
    //3 : Cong so gio
    m_gio += a.m_gio;

    return *this;
}

bool ThoiGian::bang(ThoiGian const& b) const{
    return (m_gio == b.m_gio && m_phut == b.m_phut && m_giay == b.m_giay);
}

bool ThoiGian::nhoHon(ThoiGian const& b) const {
    if (m_gio < b.m_gio)   // Neu so gio khac nhau
        return true;
    else if (m_gio == b.m_gio && m_phut < b.m_phut) //Neu cung so gio va khac so phut
        return true;
    else if (m_gio == b.m_gio && m_phut == b.m_phut && m_giay < b.m_giay) // Cung so gio va so phut thi so sanh so giay
        return true;
    else   // Neu tat ca deu sai, a se lon hon hoac bang b
        return false;
}

void ThoiGian::hienThi(ostream &out) const{
    out << m_gio << "h" << m_phut << "m" << m_giay << "s";
}

ThoiGian operator+(ThoiGian const& a, ThoiGian const& b){
    ThoiGian copie(a);
    copie += b;
    return copie;
}

ostream& operator<<(ostream& out, ThoiGian const& ThoiGian){
    ThoiGian.hienThi(out) ;
    return out;
}

bool operator==(ThoiGian const& a, ThoiGian const& b){
    return a.bang(b);
}

bool operator!=(ThoiGian const& a, ThoiGian const& b){
    if(a == b) //Su dung phep toan == da duoc dinh nghia ben tren
        return false;
    else
        return true ;
}

bool operator<(ThoiGian const &a, ThoiGian const& b) {
    return a.nhoHon(b);
}
